'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _SensorData = require('./SensorData');

var _SensorData2 = _interopRequireDefault(_SensorData);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Validator = function () {
	function Validator(types) {
		_classCallCheck(this, Validator);

		this.setTypes(types || {});
	}

	_createClass(Validator, [{
		key: 'setTypes',
		value: function setTypes(types) {
			this._types = types;
		}
	}, {
		key: 'getTypes',
		value: function getTypes() {
			return this._types;
		}
	}, {
		key: 'setType',
		value: function setType(name, type) {
			this._types[name] = type;
		}
	}, {
		key: 'getType',
		value: function getType(name) {
			return this._types[name];
		}
	}, {
		key: 'validate',
		value: function validate(data) {
			var _this = this;

			if (!(data instanceof _SensorData2.default)) throw new Error('Invalid SensorData given.');

			data.getAttributes().forEach(function (attr) {
				var value = data.getValue(attr.getName());
				var dirty = false;

				attr.getValidators().forEach(function (validator) {
					var fn = _this.getType(validator.type);

					if (typeof fn !== 'function') return;

					value = fn(value, validator.value);
					dirty = true;
				});

				if (dirty) {
					data.setValue(attr.getName(), value);
				}
			});
		}
	}]);

	return Validator;
}();

exports.default = Validator;