'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _convert = require('./types/convert');

var _convert2 = _interopRequireDefault(_convert);

var _validate = require('./types/validate');

var _validate2 = _interopRequireDefault(_validate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var extend = require('util')._extend;

exports.default = function (Server, config) {
	var server = new Server();
	var converters = extend({}, _convert2.default);
	var validators = extend({}, _validate2.default);

	if (_typeof(config.converters) === 'object') {
		converters = extend(converters, config.converters);
	}
	if (_typeof(config.validators) === 'object') {
		validators = extend(validators, config.validators);
	}

	server.setDebugMode(config.debug).setLogFile(config.logFile).setLogName(config.logName).setPort(config.port).setPayloadMaxSize(config.payloadMaxSize).setAuth(config.auth).setMetadata(config.metadata).setStorage(config.storage).setConverters(converters).setValidators(validators);

	return server;
};