'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.validate = exports.calibrate = exports.convert = undefined;

var _Converter = require('../Converter');

var _Converter2 = _interopRequireDefault(_Converter);

var _Calibrator = require('../Calibrator');

var _Calibrator2 = _interopRequireDefault(_Calibrator);

var _Validator = require('../Validator');

var _Validator2 = _interopRequireDefault(_Validator);

var _convert = require('../types/convert');

var _convert2 = _interopRequireDefault(_convert);

var _validate = require('../types/validate');

var _validate2 = _interopRequireDefault(_validate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var converter = new _Converter2.default();
var calibrator = new _Calibrator2.default();
var validator = new _Validator2.default();

var convert = exports.convert = function convert(types) {
	converter.setTypes(types || _convert2.default);

	return function (req, res, next) {
		converter.convert(req.data);
		next();
	};
};

var calibrate = exports.calibrate = function calibrate() {
	return function (req, res, next) {
		calibrator.calibrate(req.data);
		next();
	};
};

var validate = exports.validate = function validate(types) {
	validator.setTypes(types || _validate2.default);

	return function (req, res, next) {
		validator.validate(req.data);
		next();
	};
};