'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _rawBody = require('raw-body');

var _rawBody2 = _interopRequireDefault(_rawBody);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (limit) {
	limit = limit || '512kb';

	return function (req, res, next) {
		// Parse payload into buffer
		(0, _rawBody2.default)(req, {
			length: req.headers['content-length'],
			limit: limit
		}, function (err, buffer) {
			if (err) return next(err);

			if (buffer.length) {
				req.buffer = buffer;
				return next();
			}

			res.writeHead(400);
			res.end('No binary payload provided.');
		});
	};
};